RangeUnionIterator (apache-cassandra API)
Date: 2018-02-14

org.apache.cassandra.index.sasi.utils

## Class RangeUnionIterator<K extends java.lang.Comparable<K>,D extends CombinedValue<K>>

- java.lang.Object
- - org.apache.cassandra.index.sasi.utils.AbstractIterator<T>
  - - org.apache.cassandra.index.sasi.utils.RangeIterator<K,D>
    - - org.apache.cassandra.index.sasi.utils.RangeUnionIterator<K,D>

- Type Parameters:
    `K` - The type used to sort ranges.
    `D` - The container type which is going to be returned by `Iterator.next()`.
  All Implemented Interfaces:
    com.google.common.collect.PeekingIterator<D>, java.io.Closeable, java.lang.AutoCloseable, java.util.Iterator<D>

      public class RangeUnionIterator<K extends java.lang.Comparable<K>,D extends CombinedValue<K>>
      extends RangeIterator<K,D>

  Range Union Iterator is used to return sorted stream of elements from multiple RangeIterator instances. PriorityQueue is used as a sorting mechanism for the ranges, where each computeNext() operation would poll from the queue (and push when done), which returns range that contains the smallest element, because sorting is done on the moving window of range iteration `RangeIterator.getCurrent()`. Once retrieved the smallest element (return candidate) is attempted to be merged with other ranges, because there could be equal elements in adjacent ranges, such ranges are poll'ed only if their `RangeIterator.getCurrent()` equals to the return candidate.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `RangeUnionIterator.Builder<K extends java.lang.Comparable<K>,D extends CombinedValue<K>>`

    - ### Nested classes/interfaces inherited from class org.apache.cassandra.index.sasi.utils.AbstractIterator

      `AbstractIterator.State`

  - ### Field Summary

    - ### Fields inherited from class org.apache.cassandra.index.sasi.utils.AbstractIterator

      `next, state`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <K extends java.lang.Comparable<K>,D extends CombinedValue<K>> RangeIterator<K,D>` | `build(java.util.List<RangeIterator<K,D>> tokens)`
    `static <K extends java.lang.Comparable<K>,D extends CombinedValue<K>> RangeUnionIterator.Builder<K,D>` | `builder()`
    `void` | `close()`
    `D` | `computeNext()` Returns the next element.
    `protected void` | `performSkipTo(K nextToken)`

    - ### Methods inherited from class org.apache.cassandra.index.sasi.utils.RangeIterator

      `getCount, getCurrent, getMaximum, getMinimum, isOverlapping, isOverlapping, recomputeNext, skipTo, tryToComputeNext`

    - ### Methods inherited from class org.apache.cassandra.index.sasi.utils.AbstractIterator

      `endOfData, hasNext, next, peek, remove`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining`

- - ### Method Detail

    - #### computeNext

          public D computeNext()

      Description copied from class: `AbstractIterator`
      Returns the next element. Note: the implementation must call `AbstractIterator.endOfData()` when there are no elements left in the iteration. Failure to do so could result in an infinite loop.

      The initial invocation of `AbstractIterator.hasNext()` or `AbstractIterator.next()` calls this method, as does the first invocation of `hasNext` or `next` following each successful call to `next`. Once the implementation either invokes `endOfData` or throws an exception, `computeNext` is guaranteed to never be called again.

      If this method throws an exception, it will propagate outward to the `hasNext` or `next` invocation that invoked this method. Any further attempts to use the iterator will result in an `IllegalStateException`.

      The implementation of this method may not invoke the `hasNext`, `next`, or `AbstractIterator.peek()` methods on this instance; if it does, an `IllegalStateException` will result.

      Specified by:
        `computeNext` in class `AbstractIterator<D extends CombinedValue<K>>`
      Returns:
        the next element if there was one. If `endOfData` was called during execution, the return value will be ignored.

    - #### performSkipTo

          protected void performSkipTo(K nextToken)

      Specified by:
        `performSkipTo` in class `RangeIterator<K extends java.lang.Comparable<K>,D extends CombinedValue<K>>`

    - #### close

          public void close()
                     throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### builder

          public static <K extends java.lang.Comparable<K>,D extends CombinedValue<K>> RangeUnionIterator.Builder<K,D> builder()

    - #### build

          public static <K extends java.lang.Comparable<K>,D extends CombinedValue<K>> RangeIterator<K,D> build(java.util.List<RangeIterator<K,D>> tokens)

Copyright © 2018 The Apache Software Foundation